import { createRouter, createWebHashHistory } from 'vue-router'
import Login from '../views/Login.vue'
import store from '../store'

const guestGuard = (from, to, next) => {
  if (store.state.loggedIn === true)
    next({ name: 'Home' })
  else
    next()
}

const authGuard = (from, to, next) => {
  if (store.state.loggedIn === true)
    next()
  else
    next({ name: 'Login' })
}

const routes = [
  {
    path: '/',
    name: 'Login',
    component: Login,
    beforeEnter: guestGuard,
  },
  {
    path: '/home',
    name: 'Home',
    component: () => import('../views/Home.vue'),
    beforeEnter: authGuard,
  }
]

const router = createRouter({
  history: createWebHashHistory(),
  routes
})

export default router
